using System;
using System.Collections.Generic;
using System.Text;

namespace ReflectionFacade
{
    class Program
    {
        static void Main(string[] args)
        {
            object matt = Reflector.CreateInstance(typeof(Person), "Matt", "Berseth");

            //  Print the property values
            Console.WriteLine(Reflector.GetProperty(matt, "FirstName"));
            Console.WriteLine(Reflector.GetProperty(matt, "LastName"));

            //  Print the field values
            Console.WriteLine(Reflector.GetField(matt, "_firstName"));
            Console.WriteLine(Reflector.GetField(matt, "_lastName"));

            //  Set the property value
            Reflector.SetProperty(matt, "FirstName", "New First Name");
            Console.WriteLine(Reflector.GetProperty(matt, "FirstName"));

            //  Invoke a method
            Console.WriteLine(Reflector.CallMethod(matt, "FullName"));
        }
    }

    /// <summary>
    /// 
    /// </summary>
    public class Person
    {
        /// <summary>
        /// 
        /// </summary>
        private string _firstName;
        /// <summary>
        /// 
        /// </summary>
        private string _lastName;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="firstName"></param>
        /// <param name="lastName"></param>
        public Person(string firstName, string lastName)
        {
            this._firstName = firstName;
            this._lastName = lastName;
        }

        /// <summary>
        /// 
        /// </summary>
        public string FirstName
        {
            get { return this._firstName; }
            set { this._firstName = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        public string LastName
        {
            get { return this._lastName; }
            set { this._lastName = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public virtual string FullName()
        {
            return string.Format("{0} {1}", this.FirstName, this.LastName);
        }
    }

    /// <summary>
    /// 
    /// </summary>
    public class Doctor : Person
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="firstName"></param>
        /// <param name="lastName"></param>
        public Doctor(string firstName, string lastName) : base(firstName, lastName){}

        /// <summary>
        /// 
        /// </summary>
        public string Title
        {
            get { return "Dr."; }
        }

        public override string FullName()
        {
            return string.Format("{0} {1} {2}", this.Title, this.FirstName, this.LastName);
        }
    }
}
